package cn.iocoder.yudao.module.llm.service.datarefluxdata;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.llm.controller.admin.datarefluxdata.vo.*;
import cn.iocoder.yudao.module.llm.dal.dataobject.datarefluxdata.DataRefluxDataDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.llm.dal.mysql.datarefluxdata.DataRefluxDataMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * 数据回流 —— 数据 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class DataRefluxDataServiceImpl implements DataRefluxDataService {

    @Resource
    private DataRefluxDataMapper dataRefluxDataMapper;

    @Override
    public Long createDataRefluxData(DataRefluxDataSaveReqVO createReqVO) {
        // 插入
        DataRefluxDataDO dataRefluxData = BeanUtils.toBean(createReqVO, DataRefluxDataDO.class);
        dataRefluxDataMapper.insert(dataRefluxData);
        // 返回
        return dataRefluxData.getId();
    }

    @Override
    public void updateDataRefluxData(DataRefluxDataSaveReqVO updateReqVO) {
        // 校验存在
        validateDataRefluxDataExists(updateReqVO.getId());
        // 更新
        DataRefluxDataDO updateObj = BeanUtils.toBean(updateReqVO, DataRefluxDataDO.class);
        dataRefluxDataMapper.updateById(updateObj);
    }

    @Override
    public void deleteDataRefluxData(Long id) {
        // 校验存在
        validateDataRefluxDataExists(id);
        // 删除
        dataRefluxDataMapper.deleteById(id);
    }

    private void validateDataRefluxDataExists(Long id) {
        if (dataRefluxDataMapper.selectById(id) == null) {
            throw exception(DATA_REFLUX_DATA_NOT_EXISTS);
        }
    }

    @Override
    public DataRefluxDataDO getDataRefluxData(Long id) {
        return dataRefluxDataMapper.selectById(id);
    }

    @Override
    public PageResult<DataRefluxDataDO> getDataRefluxDataPage(DataRefluxDataPageReqVO pageReqVO) {
        return dataRefluxDataMapper.selectPage(pageReqVO);
    }

}